## Coding standards

First, `go fmt` must be applied for all Go-sources.

Also we use [golangci-lint](https://golangci-lint.run/) analysis tool. See [.golangci.yml](./.golangci.yml) for enabled linters. However, some pieces of source code may not pass linter checks. In this case there are instructions to disable the linter. These are the comments in the format:

```
// nolint:[linter-name][,linter-name] // description
```

So if you need to find these code-blocks search them by pattern:

```
nolint:
```

Try do not exclude any linters under configuration for [golangci-lint](./golangci.yml). __Any new code must meet__ the linter requirements!

## Proto format

As you know there is a tool named `clang-format` which able to format proto-sources. We use it too to support generic proto-formatting. It is a part of [LLVM project](https://llvm.org/). After installing the tool make appropriate settings to your IDE to use `clang-format` on saving the proto-files.

## Generating go-sources

You should install required executables before generating sources. Run `make bin-tools` under this project root. Note, if you have install these tools for different project, your may need to reinstall it again here.

## Make

Run `make` under the project root without arguments to know provided actions that are automated already.
