# Mashroom Notification

The Notification service is intended to send various notifications to Mashroom ("the platform") users.

## GRPC API

Method | Scope | Description
-|-|-
`SendEmail` | | Sends an email asynchronously using [mailyak](https://github.com/domodwyer/mailyak) or Sendgrid HTTP API
`SendEmailV2` | | Sends an email asynchronously (second version with rate limiting) using Sendgrid HTTP API
`SendSms` | | Sends a sms asynchronously using [Twilio Go client](https://github.com/sfreiberg/gotwilio)
`SendPlatform` | | Sends a platform message asynchronously using Message service
`SendEvent` | | Sends a platform event asynchronously using various channels (email/sms/platform messages)
`ListSubscribe` | | Performs anonymous Sendgrid list subscription

(TODO: a more detailed description of the methods is needed)

## GRPC coupling

Service | Use
-|-
Account | User account store (only getting data)
Offer | Offer store (only getting data)
Property | Property (real estate) store (only getting data)
Invitation | Invitation store (only getting data)
Document | Document store (only getting data)
Maintenance | Maintenance store (only getting data)
Messaging | Used by `SendPlatform`, `SendEvent` API methods to send platform messages

## Databases

DBMS | Extensions
-|-
Redis | none
  
Access abstraction: none.  
Migrations: not applicable.

Redis is used (via [go-redis](https://github.com/go-redis/redis)) as a storage and queue for asynchronous jobs.

## Zeebe integration

### Job handler ("notification-service")
Operation | Description | Input | Output
-|-|-|-
`send-platform` | Sends a platform message using the GRPC API `SendPlatform` method |id - tenant or landlord identifier <br /> body - notification text <br /> offer - offer identifier <br /> property - event property| error(optional) – error details
`send-vibrant` | Sends a special email with a CSV attached using the GRPC API `SendEmail` method | vibrantFileId - file to send identifier | error(optional) – error details

### Monitoring API

None.

## Observability

N/A

## Notes

There is also `cmd/mashroom-notification-send` utility intended to be used as a tool for sending messages from the command line.



