package embed

import (
	"context"

	notification "gitlab.mashroom.com/mashroom/backend/notification/api"

	messaging "gitlab.mashroom.com/mashroom/backend/messaging/api"
)

type recipientKeyType struct{}

var recipientKey = recipientKeyType{}

type contactsKeyType struct{}

var contactsKey = contactsKeyType{}

type embedValuesType struct{}

var embedValuesKey = embedValuesType{}

// Recipient returns recipient user ID from embed resolver context
func Recipient(ctx context.Context) string {
	raw := ctx.Value(recipientKey)
	if raw == nil {
		return ""
	}

	val, ok := raw.(string)
	if !ok {
		return ""
	}

	return val
}

// Contacts returns contacts from embed resolver context
func Contacts(ctx context.Context) *notification.Contacts {
	raw := ctx.Value(contactsKey)
	if raw == nil {
		return nil
	}

	val, ok := raw.(*notification.Contacts)
	if !ok {
		return nil
	}

	return val
}

// Embeds returns list of all embeds from embed resolver context
func Embeds(ctx context.Context) map[messaging.EmbedType][]string {
	raw := ctx.Value(embedValuesKey)
	if raw == nil {
		return make(map[messaging.EmbedType][]string)
	}

	val, ok := raw.(map[messaging.EmbedType][]string)
	if !ok {
		return make(map[messaging.EmbedType][]string)
	}

	return val
}
