// Package offer provides offer embed resolvers
package offer

import (
	"context"

	"gitlab.mashroom.com/mashroom/backend/notification/internal/embed"
	offer "gitlab.mashroom.com/mashroom/backend/offer/api"
)

// Resolver returns offer for first value
type Resolver struct {
	Offer offer.OfferServiceClient
}

// Resolve implementation
func (r *Resolver) Resolve(ctx context.Context, values ...string) (interface{}, error) {
	if len(values) == 0 {
		return nil, nil
	}

	resp, err := r.Offer.Get(ctx, &offer.GetRequest{
		Id:   values[0],
		User: embed.Recipient(ctx),
	})
	if err != nil {
		return nil, err
	}

	return embed.BindMap(resp.GetOffer()), nil
}
