// Package handlers provides api for task handlers
package handlers

import (
	"context"
	"time"

	"gitlab.mashroom.com/mashroom/backend/notification/internal/task"
)

// Handler provides implementation for notification handler
type Handler interface {
	// Run is invoked on notification delivery attempt
	Run(ctx context.Context, instance *task.Task) error
	// RetryPeriod indicated time this handler is expected to complete it's task
	// used for determining period after which task taken by a worker of this service would be reassigned to another
	RetryPeriod() time.Duration
}
