// Package sendgrid provides email handler for sendgrid email provider
package sendgrid

import (
	document "gitlab.mashroom.com/mashroom/backend/document/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/handlers"
)

// Config for handler
type Config struct {
	SendgridKey     string
	FromName        string
	FromAddress     string
	Site            string
	DocumentService document.DocumentServiceClient
}

// NewHandler returns new handler instance
func NewHandler(config *Config) handlers.Handler {
	return &handlerImpl{
		config: *config,
	}
}
