// Package smtp provides email handler for SMTP server
package smtp

import (
	"net/smtp"

	document "gitlab.mashroom.com/mashroom/backend/document/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/handlers"
)

// Config for handler
type Config struct {
	SMTPServer      string
	SMTPAuth        smtp.Auth
	FromName        string
	FromAddress     string
	Site            string
	DocumentService document.DocumentServiceClient
}

// NewHandler returns new handler instance
func NewHandler(config *Config) handlers.Handler {
	return &handlerImpl{
		config: *config,
	}
}
