// Package model provides persistence abstraction and models
package model

import (
	"context"

	"gitlab.mashroom.com/mashroom/backend/common/api/generic/query"
)

// Repository for notifications
type Repository interface {
	Migrate(ctx context.Context) error
	NotificationGetByID(ctx context.Context, id uint64) (*Notification, error)
	NotificationFilterList(ctx context.Context, params *query.QueryParams) ([]*Notification, uint64, error)
	NotificationListCustom(ctx context.Context, used []uint64) ([]*Notification, error)
	NotificationSave(ctx context.Context, n *Notification) error
	NotificationSync(ctx context.Context, n *Notification) error
	NotificationRemoveUnused(ctx context.Context, used []uint64) error
	LogSave(ctx context.Context, m *Log) error
	LogUpdateError(ctx context.Context, id uint64, err string) error
}
