package service

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/model"
	"google.golang.org/protobuf/types/known/durationpb"
)

func (srv *serviceImpl) renderNotifications(ms []*model.Notification) (ns []*notification.NotificationDefinition) {
	for _, m := range ms {
		ns = append(ns, srv.renderNotification(m))
	}

	return
}

func (srv *serviceImpl) renderNotification(m *model.Notification) *notification.NotificationDefinition {
	return &notification.NotificationDefinition{
		Entity:     m.Entity,
		Action:     m.Action,
		Target:     m.Role,
		Channel:    m.Channel,
		Template:   m.Template,
		Duration:   durationpb.New(m.Duration),
		Actor:      m.Actor,
		EscapeHtml: m.TemplateHTML,
		Customized: m.Customized,
		Disabled:   m.Disabled,
		Contacts: &notification.Contacts{
			Email:    m.Contacts.Email,
			Phone:    m.Contacts.Phone,
			Fullname: m.Contacts.Fullname,
		},
		Data: m.Data,
	}
}
