// Package expiration notification actions
package expiration

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_REMIND: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_UNKNOWN,
			// notification.EventType_EVENT_DOCUMENT_EXPIRES_REMINDER:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-7f46f0e0b79749888b7ee57133cf5ccb"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(`Your {{.document.type}} is due to expire! You can view all your`+
					` certificates and renew expired ones here: {{.site}}/certificate/{{.document.id}}`),
			),
		),
	),
}
