// Package note notification actions
package note

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_REMIND: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_ADMIN,
			// notification.EventType_EVENT_MORTGAGE_REENGAGE_REMINDER:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(
					`Reminder For a Mortgage Lead`,
				),
				template.WithGoTemplate(
					`
This is a renewal reminder that a that for a Mortgage Lead set on {{.lead.schedule_date}} by {{.lead.admin}}
<br>
Name: {{.lead.name}}
<br>
Email: {{.lead.email}}
<br>
Link to their profile: {{.lead.link}}`,
				),
			),
		),
	),
}
