// Package deposited notification actions
package deposited

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CANCEL: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_HOLDING_DEPOSIT_TENANT_WITHDRAWN_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-0dec164988ea46c8a6896f3178e2a0df"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`Applicant has withdrawn offer.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_HOLDING_DEPOSIT_TENANT_WITHDRAWN_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-8be47a6a4c854a78af8fe08a60748b42"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`You have withdrawn your offer (Holding deposit forfeited).`,
					),
				),
			),
		),
	),
	notification.Action_ACTION_REJECT: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_ADMIN,
				// notification.EventType_EVENT_OFFER_DENIED_AFTER_DEPOSIT_ADMIN:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`Urgent: Offer cancelled by Landlord`,
					),
					template.WithGoTemplate(
						`The Landlord for {{.property.name}} has cancelled a Tenant's offer after the `+
							`Holding Deposit was paid.`+
							` Therefore, the Holding Deposit needs to be refunded to the tenant
<br>
<br>
Tenant name: {{.user.name}}
<br>
Tenant email: {{.user.email}}
<br>
Holding deposit amount: {{.payment.cost}}
<br>
<br>
Please contact the tenant to ask for their bank details and process the refund of the amount shown above.
<br>
`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_HOLDING_DEPOSIT_LANDLORD_WITHDRAWN_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-e3d59648384b4415bb785d82662a6fda"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`You have withdrawn the applicants offer. They will receive their holding deposit back.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_HOLDING_DEPOSIT_LANDLORD_WITHDRAWN_NOTIFY_TENANT:
				// notification.EventType_EVENT_OFFER_DENIED_AFTER_DEPOSIT_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-f646a89d368f4f838214efcd599b97ec"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`The landlord has withdrawn your offer. You will receive your holding deposit back.`,
					),
				),
			),
		),
	),
}
