// Package payment notification actions
package payment

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_COMPLETE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_ADMIN,
				// notification.EventType_EVENT_OFFER_SERVICE_PAID_ADMIN:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`New submitted payment`,
					),
					template.WithGoTemplate(
						`Property address: {{.property.name}}<br>
Property ID: {{.property.id}}<br>
Tenants name: {{.user.name}}<br>
Payment amount: {{.payment.cost}}<br>
Submitted: {{.payment.time}}<br>
Details: {{.product.details_raw}}<br>,
`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_PAYMENT_PAID_EXTRA_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-85023eab1bb343f49437b74f03eb3c35"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Hi {{.recipient.name}},

Your payment of £{{.payment.cost}} for {{.payment.item}} has been received.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Payments`,
					),
					template.WithGoTemplate(
						`Hi {{.recipient.name}},

Your payment of £{{.payment.cost}} for {{.payment.item}} has been received, thank you.


We hope you have an amazing day ahead. `,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_PAYMENT_PAID_EXTRA_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-87dd7ae4178544ef8fea29c7c098ed04"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Hi {{.recipient.name}},

Your payment of £{{.payment.cost}} for {{.payment.item}} has been received.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Payments`,
					),
					template.WithGoTemplate(
						`Hi {{.recipient.name}},

Your payment of £{{.payment.cost}} for {{.payment.item}} has been received, thank you.

We hope you have an amazing day ahead.`,
					),
				),
			),
		),
	),
}
