// Package other notification actions
package other

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_ACCEPT: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_TENANT,
			// notification.EventType_EVENT_OFFER_LANDLORD_ACCEPTED_OTHER_TENANT:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-7ef8fc8c6c274d5fab2c43551c405fc9"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`Hi {{.recipient.name}}. Unfortunately, your offer on {{.property.name}} has been declined,`+
						` because the landlord chose a different offer`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithGoTemplate(
					`Unfortunately, your offer for {{.property.name}} has been declined,`+
						` because the landlord chose a different offer.`,
				),
			),
		),
	),
}
