// Package renewal notification actions
package renewal

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_TENANT,
			// notification.EventType_EVENT_OFFER_TENANCY_OFFERED_RENEWAL_NOTIFY_TENANT:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-04f0ccf2cd7e4fcfb67f24f26f3db509"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`The landlord has offered to renew the tenancy. Log in now to see their proposed terms.`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithTitle(
					`Tenancy renewal`,
				),
				template.WithGoTemplate(
					`Your landlord has offered you a renewal of your tenancy!`+
						` You can view the proposed terms or choose to move out by clicking here.`,
				),
			),
		),
	),
}
