// Package signature notification actions
package signature

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_COMPLETE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_SIGNING_SIGNED_MANAGER:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-a0e6de7908b247a0b1a1584742a319eb"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Great news {{.recipient.name}}! Your tenant has signed the tenancy agreement`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Agreement signed`,
					),
					template.WithGoTemplate(
						`{{.user.name}} has signed the agreement for {{.property.name}}.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_SIGNING_SIGNED_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-7590ad7fccc143289977dc8a240ea19b"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Great news {{.recipient.name}}! Your landlord has signed the tenancy agreement!`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Agreement signed`,
					),
					template.WithGoTemplate(
						`Great news! Your landlord has signed the tenancy agreement.`,
					),
				),
			),
		),
	),
	notification.Action_ACTION_PENDING: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_SIGNING_READY_MANAGER:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-7b48f2c396fd40a4acdc4fe926e698bc"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Hi {{.recipient.name}} Your tenancy agreement is ready to sign!`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Agreement ready to sign`,
					),
					template.WithGoTemplate(
						`You need to sign the agreement for {{.property.name}}.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_SIGNING_READY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-7b48f2c396fd40a4acdc4fe926e698bc"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Hi {{.recipient.name}} Your tenancy agreement is ready to sign!`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Agreement ready to sign`,
					),
					template.WithGoTemplate(
						`Please sign the tenancy agreement.`,
					),
				),
			),
		),
	),
}
