// Package invoice notification actions
package invoice

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_UPDATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_UNKNOWN,
			// notification.EventType_EVENT_PAYMENT_MASHROOM_INVOICE:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(`Mashroom invoice`),
				template.WithGoTemplate(
					`Hi {{.recipient.name}}! 
<br>
Please find attached your invoice for your recent payment on mashroom.
<br> 
If you have any questions about your order, don’t hesitate to contact us at support@mashroom.com`,
				),
			),
		),
	),
}
