// Package mandate notification actions
package mandate

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_EXPIRE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_ADMIN,
			// notification.EventType_EVENT_PAYMENT_INACTIVE_MANDATE:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(`Urgent - Direct Debit for DRP payments inactive.`),
				template.WithGoTemplate(
					`The Direct Debit which we intend to use to take a monthly Deposit Replacement `+
						`payment is currently inactive. `+
						`Please contact the tenant to make sure that they update their payment details so that `+
						`the payment can be made successfully. <br>`+
						`User: {{.recipient.name}}, {{.recipient.contact.phoneprimary}} <br>Property: `+
						`{{.property.name}}`,
				),
			),
		),
	),
}
