// Package property notification actions
package property

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_REMOVE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_ADMIN,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(
					`A property has been deleted from mashroom`,
				),
				template.WithGoTemplate(
					`The following property was deleted by the Landlord. `+
						`It has been unpublished from Rightmove and Zoopla<br> Property address: `+
						`{{.property.name}} <br> Landlord: {{.user.name}}`,
				),
			),
		),
	),
}
