// Package invitation notification actions
package invitation

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_INVITATION_CREATE_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-0a87a123c0d646398435ed76af583754"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`Your tenant {{.user.name}} has invited you to list your property with Mashroom.
Follow the instructions provided and we will have you set up in no time.`,
					),
				),
			),
		),
	),
	notification.Action_ACTION_REJECT: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_LISTING_INVITATION_REJECTED_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-ff22292b6a5a4f7eb9f8ffba8d9bd21a"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`The tenant you invited has declined your invite to become viewings manager.

You may proceed to send out additional invites via your account portal.

If you require any assistance, get in touch via {{.site}}/contact`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_LISTING_INVITATION_REJECTED_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-ff22292b6a5a4f7eb9f8ffba8d9bd21a"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`Unfortunately, the landlord {{.user.name}} you invited has rejected your invitation.`,
					),
				),
			),
		),
	),
}
