// Package unlisted notification actions
package unlisted

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_ACCEPT: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_TENANT,
			notification.Role_ROLE_LANDLORD,
			// notification.EventType_EVENT_TEAMUP_TENANT_ACCEPTS_VIEWING_HOST_BEFORE_LISTED_NOTIFY_LANDLORD
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-d7cb4d1ac5cc4a3cbe66989f735cb110"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithGoTemplate(
					`The tenant has accepted your invite for them to host viewings.`+
						` You now need to finish listing your property for tenant team up to work.`,
				),
			),
		),
	),
}
