// Package contractor notification actions
package contractor

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_MAINTENANCE_LANDLORD_ASSIGNS_CONTRACTOR_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-50be6e2705604333a626448021e7a766"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Remember to update the details of the maintenance appointment, `+
							`so the tenant is aware of the latest information. `+
							`You can update details of the appointment in your landlord dashboard.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Maintenance`,
					),
					template.WithGoTemplate(
						`Remember to update the details of the maintenance appointment through Mashroom, `+
							`so the tenant is aware of the latest information.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_MAINTENANCE_LANDLORD_ASSIGNS_CONTRACTOR_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-55b3c81abbc04fc08af154214f828627"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Your maintenance request has been assigned to a contractor. `+
							`Please visit your tenant dashboard to view the appointment date.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Maintenance`,
					),
					template.WithGoTemplate(
						`Your maintenance request has been assigned to a contractor.`,
					),
				),
			),
		),
	),
}
