// Package localheroes notification actions
package localheroes

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_MAINTENANCE_LANDLORD_ASSIGNS_LOCALHEROES_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Maintenance`,
					),
					template.WithGoTemplate(
						`The maintenance request has been assigned to Local Heroes and we’ve notified the tenant. `+
							`Look out for an email from Local Heroes with a quote for the work.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_MAINTENANCE_LANDLORD_ASSIGNS_LOCALHEROES_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-d6148f1787df4404b5f6b105e90ec8b0"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Your landlord has assigned a maintenance issue to local heroes. `+
							`View its status in your tenant dashboard.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Maintenance`,
					),
					template.WithGoTemplate(
						`Your maintenance request has been assigned to Local Heroes by the landlord.`,
					),
				),
			),
		),
	),
}
