// Package payment notification actions
package payment

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_ADMIN,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithContacts(&notification.Contacts{
					Email: "orders@mashroom.com",
				}),
				template.WithSubject(
					`New vibrant service ordered`,
				),
				template.WithGoTemplate(
					`Landlord name: {{.user.name}}<br>`+
						`Property ID: {{.property.id}}<br>`+
						`Payment amount: {{.payment.cost}}<br>`+
						`Services: {{.payment.item}}<br>`+
						`Details: {{.product.details_raw}}<br>`,
				),
			),
		),
	),
}
