// Package question notification actions
package question

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_ADMIN,
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`New question via contact page from {{.request.name}}`,
					),
					template.WithGoTemplate(
						`New question via contact page:<br><br>`+
							`Name: {{.request.name}}<br>`+
							`Email: {{.request.email}}<br>`+
							`Message: {{.request.message}}`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_AUTHOR,
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`Thank you for your feedback. It is very important for us.`,
					),
					template.WithGoTemplate(
						`Hi {{.request.name}},<br><br>Thank you for your feedback. `+
							`It is very important to us.<br><br>`+
							`Your message:<br>{{.request.message}}<br><br>This is an automated response. `+
							`We will reach out to you shortly, as soon as we process your feedback.`+
							`<br><br>Kindly let us know if you need any other assistance by `+
							`emailing us at support@mashroom.com or call us on 0113 320 7599.<br><br>`+
							`Kind Regards,<br>Team mashroom`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_PORTAL_RESPONSE:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-a06ed9f6fb8e4a28ab4374cd90242530"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Thanks for your enquiry regarding {{.property.name}}.`+
							` To book a viewing or ask the landlord a question about the property,`+
							` click here: {{.property.link}}?utm_medium=sms&utm_campaign=enquirysms`,
					),
				),
			),
		),
	),
}
