// Package task notification actions
package task

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_LANDLORD,
			// notification.EventType_EVENT_MAINTENANCE_TASK_NOTIFY_USER:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-f15cb206e05e4327a57b2b355f614a38"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`Your maintenance request has been passed to Local Heroes. `+
						`Please look out for an email/quote, `+
						`or go to your dashboard to view its current status.`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithGoTemplate(
					`Your maintenance request has been passed to Local Heroes. `+
						`Please look out for an email/quote.`,
				),
			),
		),
	),
}
