// Package tenancy notification actions
package tenancy

import (
	"time"

	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_COMPLETE: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_OFFER_TENANCY_END_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`End of tenancy`,
					),
					template.WithGoTemplate(
						`Hi {{.recipient.name}}! Tenancy ended for {{.property.name}}.`+
							` You have 10 day period to submit claims.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`End of tenancy`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_OFFER_TENANCY_END_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSubject(
						`End of tenancy`,
					),
					template.WithGoTemplate(
						`Hi {{.recipient.name}}! Tenancy ended for {{.property.name}}.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`End of tenancy`,
					),
				),
			),
		),
	),
	notification.Action_ACTION_REMIND: template.Action(
		template.WithActor(
			notification.Role_ROLE_UNKNOWN,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_OFFER_TENANCY_NEAR_END_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-f10b6fd1fcd74a4fbc2e2a6fb252fa29"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`The tenancy at {{.property.name}} is due to end in two months.`+
							` Do you want to offer renewal to the tenants?`,
					),
				),
				template.WithDuration(
					time.Hour*24*60,
					// notification.EventType_EVENT_OFFER_TENANCY_NEAR_END_NOTIFY_LANDLORD_REMINDER:
					template.WithChannel(
						notification.EventChannel_EVENT_CHANNEL_EMAIL,
						template.WithSendgridTemplate("d-b255b34b4321474687c07b958246a4b6"),
					),
					template.WithChannel(
						notification.EventChannel_EVENT_CHANNEL_PLATFORM,
						template.WithGoTemplate(
							`Reminder: The tenancy at {{.property.name}} is due to end in two months.`+
								` Do you want to offer renewal to the tenants?`,
						),
					),
				),
			),
		),
	),
}
