// Package payment notification actions
package payment

import (
	"time"

	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_COMPLETE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_LANDLORD,
			// notification.EventType_EVENT_OFFER_TENANCY_TERMINATE_CLAIM_PAID_NOTIFY_LANDLORD:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-79307e0b8fcc471caa4ca3be8bdc2ea2"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithGoTemplate(
					`Your tenant has paid their claims.`,
				),
			),
		),
	),
	notification.Action_ACTION_REMIND: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_TENANT,
			template.WithDuration(
				time.Hour*24*3,
				// notification.EventType_EVENT_OFFER_TENANCY_TERMINATE_CLAIM_AGREED_3DAYS_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-77222ae880634528a01f289d35904cb3"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`You have agreed to pay the claims amount. You have 7 days to pay the agreed amount.`,
					),
				),
			),
			template.WithDuration(
				time.Hour*24*7,
				// notification.EventType_EVENT_OFFER_TENANCY_TERMINATE_CLAIM_AGREED_7DAYS_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-e0feaf49a2ed4f9584cc575f41cdc38d"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`IMPORTANT! You have agreed to pay the claims amount. You have 3 days to pay `+
							`the agreed amount.`,
					),
				),
			),
		),
	),
}
