// Package deposit notification actions
package deposit

import (
	"time"

	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_COMPLETE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_LANDLORD,
			// notification.EventType_EVENT_OFFER_TENANCY_TERMINATE_DEPOSIT_RELEASED_NOTIFY_LANDLORD:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-51c80bc72d0c4c01a713626a3f8e4052"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithGoTemplate(
					`The 10 day period has passed and the tenant’s deposit has been released.`,
				),
			),
		),
	),
	notification.Action_ACTION_REMIND: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_LANDLORD,
			template.WithDuration(
				time.Hour*24*10,
				// notification.EventType_EVENT_OFFER_TENANCY_ENDED_DEPOSIT_REMINDER_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-6f60e5d028404997848a18f7ad18fb38"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`The tenancy has ended. You have 10 days to make a claim if necessary,`+
							` after which the deposit will be released automatically.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`You have 10 days left to make a claim, after which the deposit will be `+
							`released automatically.`,
					),
				),
			),
			template.WithDuration(
				time.Hour*24*3,
				// notification.EventType_EVENT_OFFER_TENANCY_ENDED_DEPOSIT_REMINDER_3DAYS_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-4053f1b7728547b5b240d3f24215ca54"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`IMPORTANT! You have 1 week left to make a claim,`+
							` after which the deposit will be released automatically.`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithGoTemplate(
						`IMPORTANT! You have 1 week left to make a claim,`+
							` after which the deposit will be released automatically.`,
					),
				),
			),
		),
	),
}
