// Package termination notification actions
package termination

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_LANDLORD,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_OFFER_TENANCY_CONFIRMED_TERMINATE_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-351aa6aa114844f79d464310338245a5"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Tenancy termination`,
					),
					template.WithGoTemplate(
						`Your tenancy is confirmed to end on {{.tenancy.termination_date}}.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_OFFER_TENANCY_LANDLORD_TERMINATE_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-4bc3f04a8f294e6198ddc106823b80c2"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Tenancy termination`,
					),
					template.WithGoTemplate(
						`Your tenancy will end on {{.tenancy.termination_date}}. Click here for `+
							`information on the next steps.`,
					),
				),
			),
		),
		template.WithActor(
			notification.Role_ROLE_TENANT,
			template.WithRole(
				notification.Role_ROLE_LANDLORD,
				// notification.EventType_EVENT_OFFER_TENANCY_TENANT_TERMINATE_NOTIFY_LANDLORD:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-e40ee23855cf4cacade101cd3844bb85"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Tenancy termination`,
					),
					template.WithGoTemplate(
						`Your tenant has chosen to terminate their tenancy at the end of their current contract.`+
							` Click here for information on the next steps and to relist your property with Mashroom.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_OFFER_TENANCY_TENANT_TERMINATE_NOTIFY_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-29900997d9654598a4a8a31e7256c900"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Tenancy termination`,
					),
					template.WithGoTemplate(
						`We have notified the landlord that you do not wish to proceed with their renewal proposal.`+
							` We will get back to you with next steps for end of tenancy.`,
					),
				),
			),
		),
	),
}
