// Package broadcasting notification actions
package broadcasting

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_TENANT,
			// notification.EventType_EVENT_VIEWING_BROADCASTING_STARTED:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`{{.user.firstname}} has started the video viewing.`+
						` Click the following link to join on your phone:`+
						` {{.site}}/video-viewing/{{.property.id}}/{{.viewing.id}}`+
						` You can also join on desktop by following the link in your Mashroom dashboard.`+
						` We hope you enjoy your viewing!`, // login link already added in sms_template.txt
				),
			),
		),
	),
}
