// Package favorite notification actions
package favorite

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_TENANT,
			// notification.EventType_EVENT_VIEWING_REQUEST_TENANT_FAV:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-7bd0f6c1b8164dbab43dcc5a470d0d87"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`Hi {{.recipient.name}}, why not arrange viewings for one of the properties saved in your favourites?`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithTitle(
					`Viewing Request`,
				),
				template.WithGoTemplate(
					`Hi {{.recipient.name}}, why not arrange viewings for one of the properties saved in your favourites?`,
				),
			),
		),
	),
}
