// Package reschedule notification actions
package reschedule

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_ACCEPT: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_MANAGER,
			notification.Role_ROLE_TENANT,
			// notification.EventType_EVENT_VIEWING_RESCHEDULE_ACCEPT_TENANT:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-4badd5ebbcb24d9ca9248a29363e57ea"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`Hi {{.recipient.name}}. Your request for a rescheduled viewing has been accepted!`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithTitle(
					`Viewing Reschedule Accepted`,
				),
				template.WithGoTemplate(
					`Your viewing request has been accepted! `,
				),
			),
		),
		template.WithActorRole(
			notification.Role_ROLE_TENANT,
			notification.Role_ROLE_MANAGER,
			// notification.EventType_EVENT_VIEWING_RESCHEDULE_ACCEPT_MANAGER:
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSendgridTemplate("d-86e80ae941b1475bb05894b199b89763"),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`Good news {{.recipient.name}}. Your request for a rescheduled viewing has been accepted!`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_PLATFORM,
				template.WithTitle(
					`Viewing Reschedule Accepted`,
				),
				template.WithGoTemplate(
					`Your viewing request has been accepted! `,
				),
			),
		),
	),
	notification.Action_ACTION_CREATE: template.Action(
		template.WithActor(
			notification.Role_ROLE_MANAGER,
			template.WithRole(
				notification.Role_ROLE_MANAGER,
				// notification.EventType_EVENT_VIEWING_RESCHEDULE_REQUEST_MANAGER_CONFIRM:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-ffb1fe4775674c2eb7165241cf2b780f"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Viewing Reschedule Request`,
					),
					template.WithGoTemplate(
						`Your reschedule request has been sent to the viewer.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_VIEWING_RESCHEDULE_REQUEST_TENANT:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-7c7c4388e1364284af0ed6b698072bd9"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`Hey {{.recipient.name}}, {{.user.name}} has requested to reschedule the viewing!`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Viewing Reschedule Request`,
					),
					template.WithGoTemplate(
						`{{.user.name}} has requested to reschedule their viewing!`,
					),
				),
			),
		),
		template.WithActor(
			notification.Role_ROLE_TENANT,
			template.WithRole(
				notification.Role_ROLE_MANAGER,
				// notification.EventType_EVENT_VIEWING_RESCHEDULE_REQUEST_MANAGER:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-c1c3f34fd1144d8a9c9806f159a60212"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_SMS,
					template.WithGoTemplate(
						`{{.user.name}} has requested to reschedule their viewing!`,
					),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Viewing Reschedule Request`,
					),
					template.WithGoTemplate(
						`The applicant has requested to reschedule their viewing request for {{.property.name}}.`,
					),
				),
			),
			template.WithRole(
				notification.Role_ROLE_TENANT,
				// notification.EventType_EVENT_VIEWING_RESCHEDULE_REQUEST_TENANT_CONFIRM:
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_EMAIL,
					template.WithSendgridTemplate("d-bfc96823da0d42eca8fb06dd5ab66b80"),
				),
				template.WithChannel(
					notification.EventChannel_EVENT_CHANNEL_PLATFORM,
					template.WithTitle(
						`Viewing Reschedule Request`,
					),
					template.WithGoTemplate(
						`Your request to reschedule the viewing at {{.property.location.city}} has been sent to the landlord.`,
					),
				),
			),
		),
	),
}
