// Package email notification actions
package email

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_UPDATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_AUTHOR,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(
					`Mashroom email address change notification`,
				),
				template.WithGoTemplate(
					`You have changed you MashroomId to {{.new_email}} recently. `+
						`Please contact Mashroom support if you have not done this.`,
				),
			),
		),
	),
	notification.Action_ACTION_VERIFY: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_AUTHOR,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(
					`Verify your email for Mashroom`,
				),
				template.WithGoTemplate(
					`To verify your email, use this code: {{.token}}`,
				),
			),
		),
	),
}
