// Package phone notification actions
package phone

import (
	notification "gitlab.mashroom.com/mashroom/backend/notification/api"
	"gitlab.mashroom.com/mashroom/backend/notification/internal/template"
)

// Registry map
var Registry = template.ActionMap{
	notification.Action_ACTION_UPDATE: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_AUTHOR,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_EMAIL,
				template.WithSubject(
					`Mashroom phone number change notification`,
				),
				template.WithGoTemplate(
					`You have changed you Mashroom phone number to {{.new_phone}} recently. `+
						`Please contact Mashroom support if you have not done this`,
				),
			),
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`You have changed you Mashroom phone number to {{.new_phone}} recently. `+
						`Please contact Mashroom support if you have not done this`,
				),
			),
		),
	),
	notification.Action_ACTION_VERIFY: template.Action(
		template.WithActorRole(
			notification.Role_ROLE_UNKNOWN,
			notification.Role_ROLE_AUTHOR,
			template.WithChannel(
				notification.EventChannel_EVENT_CHANNEL_SMS,
				template.WithGoTemplate(
					`To verify your phone number, please enter this code: {{.token}}`,
				),
			),
		),
	),
}
